diff --git a/python/pytest/_pytest/assertion/util.py b/python/pytest/_pytest/assertion/util.py
index f2f23efea2..d384d804b3 100644
--- a/python/pytest/_pytest/assertion/util.py
+++ b/python/pytest/_pytest/assertion/util.py
@@ -4,7 +4,7 @@ import pprint
 import _pytest._code
 import py
 try:
-    from collections import Sequence
+    from collections.abc import Sequence
 except ImportError:
     Sequence = list
 
@@ -66,7 +66,7 @@ def _collapse_false(explanation):
                     break
             prev_c = c
         else:
-            raise AssertionError("unbalanced braces: %r" % (explanation,))
+            raise AssertionError("unbalanced braces: {!r}".format(explanation))
         end = start + i
         where = end
         if explanation[end - 1] == '\n':
@@ -130,9 +130,9 @@ def _format_lines(lines):
 
 # Provide basestring in python3
 try:
-    basestring = basestring
+    str = str
 except NameError:
-    basestring = str
+    str = str
 
 
 def assertrepr_compare(config, op, left, right):
@@ -144,8 +144,8 @@ def assertrepr_compare(config, op, left, right):
     summary = u('%s %s %s') % (ecu(left_repr), op, ecu(right_repr))
 
     issequence = lambda x: (isinstance(x, (list, tuple, Sequence)) and
-                            not isinstance(x, basestring))
-    istext = lambda x: isinstance(x, basestring)
+                            not isinstance(x, str))
+    istext = lambda x: isinstance(x, str)
     isdict = lambda x: isinstance(x, dict)
     isset = lambda x: isinstance(x, (set, frozenset))
 
@@ -287,14 +287,14 @@ def _compare_eq_set(left, right, verbose=False):
 def _compare_eq_dict(left, right, verbose=False):
     explanation = []
     common = set(left).intersection(set(right))
-    same = dict((k, left[k]) for k in common if left[k] == right[k])
+    same = {k: left[k] for k in common if left[k] == right[k]}
     if same and not verbose:
         explanation += [u('Omitting %s identical items, use -v to show') %
                         len(same)]
     elif same:
         explanation += [u('Common items:')]
         explanation += pprint.pformat(same).splitlines()
-    diff = set(k for k in common if left[k] != right[k])
+    diff = {k for k in common if left[k] != right[k]}
     if diff:
         explanation += [u('Differing items:')]
         for k in diff:
@@ -304,12 +304,12 @@ def _compare_eq_dict(left, right, verbose=False):
     if extra_left:
         explanation.append(u('Left contains more items:'))
         explanation.extend(pprint.pformat(
-            dict((k, left[k]) for k in extra_left)).splitlines())
+            {k: left[k] for k in extra_left}).splitlines())
     extra_right = set(right) - set(left)
     if extra_right:
         explanation.append(u('Right contains more items:'))
         explanation.extend(pprint.pformat(
-            dict((k, right[k]) for k in extra_right)).splitlines())
+            {k: right[k] for k in extra_right}).splitlines())
     return explanation
 
 
diff --git a/python/pytest/_pytest/cacheprovider.py b/python/pytest/_pytest/cacheprovider.py
index 0657001f2d..0606673060 100755
--- a/python/pytest/_pytest/cacheprovider.py
+++ b/python/pytest/_pytest/cacheprovider.py
@@ -11,7 +11,7 @@ import json
 from os.path import sep as _sep, altsep as _altsep
 
 
-class Cache(object):
+class Cache:
     def __init__(self, config):
         self.config = config
         self._cachedir = config.rootdir.join(".cache")
@@ -56,7 +56,7 @@ class Cache(object):
                 with path.open("r") as f:
                     return json.load(f)
             except ValueError:
-                self.trace("cache-invalid at %s" % (path,))
+                self.trace("cache-invalid at {}".format(path))
         return default
 
     def set(self, key, value):
@@ -73,17 +73,17 @@ class Cache(object):
             path.dirpath().ensure_dir()
         except (py.error.EEXIST, py.error.EACCES):
             self.config.warn(
-                code='I9', message='could not create cache path %s' % (path,)
+                code='I9', message='could not create cache path {}'.format(path)
             )
             return
         try:
             f = path.open('w')
         except py.error.ENOTDIR:
             self.config.warn(
-                code='I9', message='cache could not write path %s' % (path,))
+                code='I9', message='cache could not write path {}'.format(path))
         else:
             with f:
-                self.trace("cache-write %s: %r" % (key, value,))
+                self.trace("cache-write {}: {!r}".format(key, value))
                 json.dump(value, f, indent=2, sort_keys=True)
 
 
diff --git a/python/pytest/_pytest/capture.py b/python/pytest/_pytest/capture.py
index 3895a714aa..3b93f25c88 100644
--- a/python/pytest/_pytest/capture.py
+++ b/python/pytest/_pytest/capture.py
@@ -2,7 +2,6 @@
 per-test stdout/stderr capturing mechanism.
 
 """
-from __future__ import with_statement
 
 import sys
 import os
@@ -12,7 +11,7 @@ import py
 import pytest
 
 from py.io import TextIO
-unicode = py.builtin.text
+str = py.builtin.text
 
 patchsysdict = {0: 'stdin', 1: 'stdout', 2: 'stderr'}
 
@@ -220,14 +219,14 @@ def safe_text_dupfile(f, mode, default_encoding="UTF8"):
     return EncodedFile(f, encoding or default_encoding)
 
 
-class EncodedFile(object):
+class EncodedFile:
     errors = "strict"  # possibly needed by py3 code (issue555)
     def __init__(self, buffer, encoding):
         self.buffer = buffer
         self.encoding = encoding
 
     def write(self, obj):
-        if isinstance(obj, unicode):
+        if isinstance(obj, str):
             obj = obj.encode(self.encoding, "replace")
         self.buffer.write(obj)
 
@@ -239,7 +238,7 @@ class EncodedFile(object):
         return getattr(object.__getattribute__(self, "buffer"), name)
 
 
-class MultiCapture(object):
+class MultiCapture:
     out = err = in_ = None
 
     def __init__(self, out=True, err=True, in_=True, Capture=None):
@@ -318,7 +317,7 @@ class FDCapture:
         else:
             if targetfd == 0:
                 assert not tmpfile, "cannot set tmpfile with stdin"
-                tmpfile = open(os.devnull, "r")
+                tmpfile = open(os.devnull)
                 self.syscapture = SysCapture(targetfd)
             else:
                 if tmpfile is None:
@@ -333,7 +332,7 @@ class FDCapture:
             self.tmpfile_fd = tmpfile.fileno()
 
     def __repr__(self):
-        return "<FDCapture %s oldfd=%s>" % (self.targetfd, self.targetfd_save)
+        return "<FDCapture {} oldfd={}>".format(self.targetfd, self.targetfd_save)
 
     def start(self):
         """ Start capturing on targetfd using memorized tmpfile. """
@@ -430,7 +429,7 @@ class DontReadFromInput:
     encoding = None
 
     def read(self, *args):
-        raise IOError("reading from stdin while output is captured")
+        raise OSError("reading from stdin while output is captured")
     readline = read
     readlines = read
     __iter__ = read
diff --git a/python/pytest/_pytest/config.py b/python/pytest/_pytest/config.py
index 9a308df2bb..a83781d7d5 100644
--- a/python/pytest/_pytest/config.py
+++ b/python/pytest/_pytest/config.py
@@ -103,7 +103,7 @@ def _prepareconfig(args=None, plugins=None):
         args = [str(args)]
     elif not isinstance(args, (tuple, list)):
         if not isinstance(args, str):
-            raise ValueError("not a string or argument list: %r" % (args,))
+            raise ValueError("not a string or argument list: {!r}".format(args))
         args = shlex.split(args, posix=sys.platform != "win32")
     config = get_config()
     pluginmanager = config.pluginmanager
@@ -131,7 +131,7 @@ class PytestPluginManager(PluginManager):
     * ``conftest.py`` loading during start-up;
     """
     def __init__(self):
-        super(PytestPluginManager, self).__init__("pytest", implprefix="pytest_")
+        super().__init__("pytest", implprefix="pytest_")
         self._conftest_plugins = set()
 
         # state related to local conftest plugins
@@ -177,14 +177,14 @@ class PytestPluginManager(PluginManager):
             return
 
         method = getattr(plugin, name)
-        opts = super(PytestPluginManager, self).parse_hookimpl_opts(plugin, name)
+        opts = super().parse_hookimpl_opts(plugin, name)
         if opts is not None:
             for name in ("tryfirst", "trylast", "optionalhook", "hookwrapper"):
                 opts.setdefault(name, hasattr(method, name))
         return opts
 
     def parse_hookspec_opts(self, module_or_class, name):
-        opts = super(PytestPluginManager, self).parse_hookspec_opts(
+        opts = super().parse_hookspec_opts(
                                                 module_or_class, name)
         if opts is None:
             method = getattr(module_or_class, name)
@@ -194,7 +194,7 @@ class PytestPluginManager(PluginManager):
         return opts
 
     def _verify_hook(self, hook, hookmethod):
-        super(PytestPluginManager, self)._verify_hook(hook, hookmethod)
+        super()._verify_hook(hook, hookmethod)
         if "__multicall__" in hookmethod.argnames:
             fslineno = _pytest._code.getfslineno(hookmethod.function)
             warning = dict(code="I1",
@@ -205,7 +205,7 @@ class PytestPluginManager(PluginManager):
             self._warn(warning)
 
     def register(self, plugin, name=None):
-        ret = super(PytestPluginManager, self).register(plugin, name)
+        ret = super().register(plugin, name)
         if ret:
             self.hook.pytest_plugin_registered.call_historic(
                       kwargs=dict(plugin=plugin, manager=self))
@@ -384,7 +384,7 @@ class PytestPluginManager(PluginManager):
         try:
             __import__(importspec)
         except ImportError as e:
-            new_exc = ImportError('Error importing plugin "%s": %s' % (modname, e))
+            new_exc = ImportError('Error importing plugin "{}": {}'.format(modname, e))
             # copy over name and path attributes
             for attr in ('name', 'path'):
                 if hasattr(e, attr):
@@ -531,7 +531,7 @@ class ArgumentError(Exception):
 
     def __str__(self):
         if self.option_id:
-            return "option %s: %s" % (self.option_id, self.msg)
+            return "option {}: {}".format(self.option_id, self.msg)
         else:
             return self.msg
 
@@ -722,7 +722,7 @@ class MyOptionParser(argparse.ArgumentParser):
                 if arg and arg[0] == '-':
                     lines = ['unrecognized arguments: %s' % (' '.join(argv))]
                     for k, v in sorted(self.extra_info.items()):
-                        lines.append('  %s: %s' % (k, v))
+                        lines.append('  {}: {}'.format(k, v))
                     self.error('\n'.join(lines))
             getattr(args, FILE_OR_DIR).extend(argv)
         return args
@@ -784,7 +784,7 @@ def _ensure_removed_sysmodule(modname):
     except KeyError:
         pass
 
-class CmdOptions(object):
+class CmdOptions:
     """ holds cmdline options as attributes."""
     def __init__(self, values=()):
         self.__dict__.update(values)
@@ -800,7 +800,7 @@ class Notset:
 notset = Notset()
 FILE_OR_DIR = 'file_or_dir'
 
-class Config(object):
+class Config:
     """ access to configuration values, pluginmanager and plugin hooks.  """
 
     def __init__(self, pluginmanager):
@@ -809,7 +809,7 @@ class Config(object):
         self.option = CmdOptions()
         _a = FILE_OR_DIR
         self._parser = Parser(
-            usage="%%(prog)s [options] [%s] [%s] [...]" % (_a, _a),
+            usage="%(prog)s [options] [{}] [{}] [...]".format(_a, _a),
             processopt=self._processopt,
         )
         #: a pluginmanager instance
@@ -926,7 +926,7 @@ class Config(object):
         try:
             self.pluginmanager.load_setuptools_entrypoints("pytest11")
         except ImportError as e:
-            self.warn("I2", "could not load setuptools entry import: %s" % (e,))
+            self.warn("I2", "could not load setuptools entry import: {}".format(e))
         self.pluginmanager.consider_env()
         self.known_args_namespace = ns = self._parser.parse_known_args(args, namespace=self.option.copy())
         if self.known_args_namespace.confcutdir is None and self.inifile:
@@ -1016,7 +1016,7 @@ class Config(object):
         elif type == "args":
             return shlex.split(value)
         elif type == "linelist":
-            return [t for t in map(lambda x: x.strip(), value.split("\n")) if t]
+            return [t for t in [x.strip() for x in value.split("\n")] if t]
         elif type == "bool":
             return bool(_strtobool(value.strip()))
         else:
@@ -1058,7 +1058,7 @@ class Config(object):
             if skip:
                 import pytest
                 pytest.skip("no %r option found" %(name,))
-            raise ValueError("no option named %r" % (name,))
+            raise ValueError("no option named {!r}".format(name))
 
     def getvalue(self, name, path=None):
         """ (deprecated, use getoption()) """
@@ -1189,4 +1189,4 @@ def _strtobool(val):
     elif val in ('n', 'no', 'f', 'false', 'off', '0'):
         return 0
     else:
-        raise ValueError("invalid truth value %r" % (val,))
+        raise ValueError("invalid truth value {!r}".format(val))
diff --git a/python/pytest/_pytest/doctest.py b/python/pytest/_pytest/doctest.py
index a57f7a4949..368487db28 100644
--- a/python/pytest/_pytest/doctest.py
+++ b/python/pytest/_pytest/doctest.py
@@ -1,5 +1,4 @@
 """ discover and run doctests in modules and test files."""
-from __future__ import absolute_import
 
 import traceback
 
@@ -61,7 +60,7 @@ class ReprFailDoctest(TerminalRepr):
 class DoctestItem(pytest.Item):
 
     def __init__(self, name, parent, runner=None, dtest=None):
-        super(DoctestItem, self).__init__(name, parent)
+        super().__init__(name, parent)
         self.runner = runner
         self.dtest = dtest
         self.obj = None
@@ -78,7 +77,7 @@ class DoctestItem(pytest.Item):
         self.runner.run(self.dtest)
 
     def repr_failure(self, excinfo):
-        import doctest
+        from . import doctest
         if excinfo.errisinstance((doctest.DocTestFailure,
                                   doctest.UnexpectedException)):
             doctestfailure = excinfo.value
@@ -104,7 +103,7 @@ class DoctestItem(pytest.Item):
                 lines = ['EXAMPLE LOCATION UNKNOWN, not showing all tests of that example']
                 indent = '>>>'
                 for line in example.source.splitlines():
-                    lines.append('??? %s %s' % (indent, line))
+                    lines.append('??? {} {}'.format(indent, line))
                     indent = '...'
             if excinfo.errisinstance(doctest.DocTestFailure):
                 lines += checker.output_difference(example,
@@ -116,14 +115,14 @@ class DoctestItem(pytest.Item):
                 lines += traceback.format_exception(*excinfo.value.exc_info)
             return ReprFailDoctest(reprlocation, lines)
         else:
-            return super(DoctestItem, self).repr_failure(excinfo)
+            return super().repr_failure(excinfo)
 
     def reportinfo(self):
         return self.fspath, None, "[doctest] %s" % self.name
 
 
 def _get_flag_lookup():
-    import doctest
+    from . import doctest
     return dict(DONT_ACCEPT_TRUE_FOR_1=doctest.DONT_ACCEPT_TRUE_FOR_1,
                 DONT_ACCEPT_BLANKLINE=doctest.DONT_ACCEPT_BLANKLINE,
                 NORMALIZE_WHITESPACE=doctest.NORMALIZE_WHITESPACE,
@@ -147,7 +146,7 @@ def get_optionflags(parent):
 class DoctestTextfile(DoctestItem, pytest.Module):
 
     def runtest(self):
-        import doctest
+        from . import doctest
         fixture_request = _setup_fixtures(self)
 
         # inspired by doctest.testfile; ideally we would use it directly,
@@ -173,7 +172,7 @@ def _check_all_skipped(test):
     """raises pytest.skip() if all examples in the given DocTest have the SKIP
     option set.
     """
-    import doctest
+    from . import doctest
     all_skipped = all(x.options.get(doctest.SKIP, False) for x in test.examples)
     if all_skipped:
         pytest.skip('all tests skipped by +SKIP option')
@@ -181,7 +180,7 @@ def _check_all_skipped(test):
 
 class DoctestModule(pytest.Module):
     def collect(self):
-        import doctest
+        from . import doctest
         if self.fspath.basename == "conftest.py":
             module = self.config.pluginmanager._importconftest(self.fspath)
         else:
@@ -231,7 +230,7 @@ def _get_checker():
     if hasattr(_get_checker, 'LiteralsOutputChecker'):
         return _get_checker.LiteralsOutputChecker()
 
-    import doctest
+    from . import doctest
     import re
 
     class LiteralsOutputChecker(doctest.OutputChecker):
@@ -278,7 +277,7 @@ def _get_allow_unicode_flag():
     """
     Registers and returns the ALLOW_UNICODE flag.
     """
-    import doctest
+    from . import doctest
     return doctest.register_optionflag('ALLOW_UNICODE')
 
 
@@ -286,5 +285,5 @@ def _get_allow_bytes_flag():
     """
     Registers and returns the ALLOW_BYTES flag.
     """
-    import doctest
+    from . import doctest
     return doctest.register_optionflag('ALLOW_BYTES')
diff --git a/python/pytest/_pytest/helpconfig.py b/python/pytest/_pytest/helpconfig.py
index 1df0c56ac7..ac6e9f0a5c 100644
--- a/python/pytest/_pytest/helpconfig.py
+++ b/python/pytest/_pytest/helpconfig.py
@@ -76,7 +76,7 @@ def showhelp(config):
         help, type, default = config._parser._inidict[name]
         if type is None:
             type = "string"
-        spec = "%s (%s)" % (name, type)
+        spec = "{} ({})".format(name, type)
         line = "  %-24s %s" %(spec, help)
         tw.line(line[:tw.fullwidth])
 
@@ -113,7 +113,7 @@ def getpluginversioninfo(config):
         lines.append("setuptools registered plugins:")
         for plugin, dist in plugininfo:
             loc = getattr(plugin, '__file__', repr(plugin))
-            content = "%s-%s at %s" % (dist.project_name, dist.version, loc)
+            content = "{}-{} at {}".format(dist.project_name, dist.version, loc)
             lines.append("  " + content)
     return lines
 
diff --git a/python/pytest/_pytest/junitxml.py b/python/pytest/_pytest/junitxml.py
index f4de1343ed..aa54a608e0 100644
--- a/python/pytest/_pytest/junitxml.py
+++ b/python/pytest/_pytest/junitxml.py
@@ -14,14 +14,12 @@ import re
 import sys
 import time
 import pytest
+unichr = chr
 
 # Python 2.X and 3.X compatibility
-if sys.version_info[0] < 3:
-    from codecs import open
-else:
-    unichr = chr
-    unicode = str
-    long = int
+unichr = chr
+str = str
+long = int
 
 
 class Junit(py.xml.Namespace):
@@ -37,11 +35,11 @@ _legal_ranges = (
     (0x20, 0x7E), (0x80, 0xD7FF), (0xE000, 0xFFFD), (0x10000, 0x10FFFF),
 )
 _legal_xml_re = [
-    unicode("%s-%s") % (unichr(low), unichr(high))
+    str("%s-%s") % (unichr(low), unichr(high))
     for (low, high) in _legal_ranges if low < sys.maxunicode
 ]
 _legal_xml_re = [unichr(x) for x in _legal_chars] + _legal_xml_re
-illegal_xml_re = re.compile(unicode('[^%s]') % unicode('').join(_legal_xml_re))
+illegal_xml_re = re.compile(str('[^%s]') % str('').join(_legal_xml_re))
 del _legal_chars
 del _legal_ranges
 del _legal_xml_re
@@ -53,14 +51,14 @@ def bin_xml_escape(arg):
     def repl(matchobj):
         i = ord(matchobj.group())
         if i <= 0xFF:
-            return unicode('#x%02X') % i
+            return str('#x%02X') % i
         else:
-            return unicode('#x%04X') % i
+            return str('#x%04X') % i
 
     return py.xml.raw(illegal_xml_re.sub(repl, py.xml.escape(arg)))
 
 
-class _NodeReporter(object):
+class _NodeReporter:
     def __init__(self, nodeid, xml):
 
         self.id = nodeid
@@ -139,7 +137,7 @@ class _NodeReporter(object):
         else:
             if hasattr(report.longrepr, "reprcrash"):
                 message = report.longrepr.reprcrash.message
-            elif isinstance(report.longrepr, (unicode, str)):
+            elif isinstance(report.longrepr, (str, str)):
                 message = report.longrepr
             else:
                 message = str(report.longrepr)
@@ -173,13 +171,13 @@ class _NodeReporter(object):
             if skipreason.startswith("Skipped: "):
                 skipreason = bin_xml_escape(skipreason[9:])
             self.append(
-                Junit.skipped("%s:%s: %s" % (filename, lineno, skipreason),
+                Junit.skipped("{}:{}: {}".format(filename, lineno, skipreason),
                               type="pytest.skip",
                               message=skipreason))
         self._write_captured_output(report)
 
     def finalize(self):
-        data = self.to_xml().unicode(indent=0)
+        data = self.to_xml().str(indent=0)
         self.__dict__.clear()
         self.to_xml = lambda: py.xml.raw(data)
 
@@ -252,7 +250,7 @@ def mangle_test_address(address):
     return names
 
 
-class LogXML(object):
+class LogXML:
     def __init__(self, logfile, prefix):
         logfile = os.path.expanduser(os.path.expandvars(logfile))
         self.logfile = os.path.normpath(os.path.abspath(logfile))
@@ -379,7 +377,7 @@ class LogXML(object):
             failures=self.stats['failure'],
             skips=self.stats['skipped'],
             tests=numtests,
-            time="%.3f" % suite_time_delta, ).unicode(indent=0))
+            time="%.3f" % suite_time_delta, ).str(indent=0))
         logfile.close()
 
     def pytest_terminal_summary(self, terminalreporter):
diff --git a/python/pytest/_pytest/main.py b/python/pytest/_pytest/main.py
index 8654d7af62..5d9598bb66 100644
--- a/python/pytest/_pytest/main.py
+++ b/python/pytest/_pytest/main.py
@@ -9,7 +9,7 @@ import _pytest._code
 import py
 import pytest
 try:
-    from collections import MutableMapping as MappingMixin
+    from collections.abc import MutableMapping as MappingMixin
 except ImportError:
     from UserDict import DictMixin as MappingMixin
 
@@ -25,7 +25,7 @@ EXIT_INTERNALERROR = 3
 EXIT_USAGEERROR = 4
 EXIT_NOTESTSCOLLECTED = 5
 
-name_re = re.compile("^[a-zA-Z_]\w*$")
+name_re = re.compile(r"^[a-zA-Z_]\w*$")
 
 def pytest_addoption(parser):
     parser.addini("norecursedirs", "directory patterns to avoid for recursion",
@@ -212,10 +212,10 @@ class NodeKeywords(MappingMixin):
         return list(self)
 
     def __repr__(self):
-        return "<NodeKeywords for node %s>" % (self.node, )
+        return "<NodeKeywords for node {}>".format(self.node)
 
 
-class Node(object):
+class Node:
     """ base class for Collector and Item the test collection tree.
     Collector subclasses have children, Items are terminal nodes."""
 
@@ -451,7 +451,7 @@ class FSCollector(Collector):
             if rel:
                 name = rel
             name = name.replace(os.sep, "/")
-        super(FSCollector, self).__init__(name, parent, config, session)
+        super().__init__(name, parent, config, session)
         self.fspath = fspath
 
     def _makeid(self):
@@ -470,7 +470,7 @@ class Item(Node):
     nextitem = None
 
     def __init__(self, name, parent=None, config=None, session=None):
-        super(Item, self).__init__(name, parent, config, session)
+        super().__init__(name, parent, config, session)
         self._report_sections = []
 
     def add_report_section(self, when, key, content):
@@ -589,8 +589,8 @@ class Session(FSCollector):
         if self._notfound:
             errors = []
             for arg, exc in self._notfound:
-                line = "(no name %r in any of %r)" % (arg, exc.args[0])
-                errors.append("not found: %s\n%s" % (arg, line))
+                line = "(no name {!r} in any of {!r})".format(arg, exc.args[0])
+                errors.append("not found: {}\n{}".format(arg, line))
                 #XXX: test this
             raise pytest.UsageError(*errors)
         if not genitems:
@@ -607,8 +607,7 @@ class Session(FSCollector):
             self.trace("processing argument", arg)
             self.trace.root.indent += 1
             try:
-                for x in self._collect(arg):
-                    yield x
+                yield from self._collect(arg)
             except NoMatch:
                 # we are inside a make_report hook so
                 # we cannot directly pass through the exception
@@ -739,6 +738,5 @@ class Session(FSCollector):
             rep = collect_one_node(node)
             if rep.passed:
                 for subnode in rep.result:
-                    for x in self.genitems(subnode):
-                        yield x
+                    yield from self.genitems(subnode)
             node.ihook.pytest_collectreport(report=rep)
diff --git a/python/pytest/_pytest/mark.py b/python/pytest/_pytest/mark.py
index d8b60def36..e30169292f 100644
--- a/python/pytest/_pytest/mark.py
+++ b/python/pytest/_pytest/mark.py
@@ -196,7 +196,7 @@ class MarkGenerator:
             x = beginning[0].split("(", 1)[0]
             l.add(x)
         if name not in self._markers:
-            raise AttributeError("%r not a registered marker" % (name,))
+            raise AttributeError("{!r} not a registered marker".format(name))
 
 def istestfunc(func):
     return hasattr(func, "__call__") and \
@@ -247,7 +247,7 @@ class MarkDecorator:
     def __repr__(self):
         d = self.__dict__.copy()
         name = d.pop('name')
-        return "<MarkDecorator %r %r>" % (name, d)
+        return "<MarkDecorator {!r} {!r}>".format(name, d)
 
     def __call__(self, *args, **kwargs):
         """ if passed a single callable argument: decorate it with mark info.
@@ -295,7 +295,7 @@ class MarkInfo:
         self._arglist = [(args, kwargs.copy())]
 
     def __repr__(self):
-        return "<MarkInfo %r args=%r kwargs=%r>" % (
+        return "<MarkInfo {!r} args={!r} kwargs={!r}>".format(
             self.name, self.args, self.kwargs
         )
 
diff --git a/python/pytest/_pytest/monkeypatch.py b/python/pytest/_pytest/monkeypatch.py
index d4c169d37a..bbb46c00af 100644
--- a/python/pytest/_pytest/monkeypatch.py
+++ b/python/pytest/_pytest/monkeypatch.py
@@ -56,7 +56,7 @@ def resolve(name):
                 raise
             else:
                 raise ImportError(
-                    'import error in %s: %s' % (used, ex)
+                    'import error in {}: {}'.format(used, ex)
                 )
         found = annotated_getattr(found, part, used)
     return found
@@ -67,7 +67,7 @@ def annotated_getattr(obj, name, ann):
         obj = getattr(obj, name)
     except AttributeError:
         raise AttributeError(
-                '%r object at %s has no attribute %r' % (
+                '{!r} object at {} has no attribute {!r}'.format(
                     type(obj).__name__, ann, name
                 )
         )
@@ -129,7 +129,7 @@ class monkeypatch:
 
         oldval = getattr(target, name, notset)
         if raising and oldval is notset:
-            raise AttributeError("%r has no attribute %r" % (target, name))
+            raise AttributeError("{!r} has no attribute {!r}".format(target, name))
 
         # avoid class descriptors like staticmethod/classmethod
         if inspect.isclass(target):
diff --git a/python/pytest/_pytest/pastebin.py b/python/pytest/_pytest/pastebin.py
index 4ec62d0228..8e103db57e 100644
--- a/python/pytest/_pytest/pastebin.py
+++ b/python/pytest/_pytest/pastebin.py
@@ -53,11 +53,8 @@ def create_new_paste(contents):
     :returns: url to the pasted contents
     """
     import re
-    if sys.version_info < (3, 0):
-        from urllib import urlopen, urlencode
-    else:
-        from urllib.request import urlopen
-        from urllib.parse import urlencode
+    from urllib.request import urlopen
+    from urllib.parse import urlencode
 
     params = {
         'code': contents,
@@ -68,7 +65,7 @@ def create_new_paste(contents):
     response = urlopen(url, data=urlencode(params).encode('ascii')).read()
     m = re.search(r'href="/raw/(\w+)"', response.decode('utf-8'))
     if m:
-        return '%s/show/%s' % (url, m.group(1))
+        return '{}/show/{}'.format(url, m.group(1))
     else:
         return 'bad response: ' + response
 
diff --git a/python/pytest/_pytest/pdb.py b/python/pytest/_pytest/pdb.py
index 84c920d172..256863f0cb 100644
--- a/python/pytest/_pytest/pdb.py
+++ b/python/pytest/_pytest/pdb.py
@@ -1,6 +1,5 @@
 """ interactive debugging with PDB, the Python Debugger. """
-from __future__ import absolute_import
-import pdb
+from . import pdb
 import sys
 
 import pytest
@@ -83,7 +82,7 @@ def _enter_pdb(node, excinfo, rep):
 def _postmortem_traceback(excinfo):
     # A doctest.UnexpectedException is not useful for post_mortem.
     # Use the underlying exception instead:
-    from doctest import UnexpectedException
+    from .doctest import UnexpectedException
     if isinstance(excinfo.value, UnexpectedException):
         return excinfo.value.exc_info[2]
     else:
